Subject: Unique SSRC IDs?

From: Martin Mauve <[email-masked]>
Date: Wed, 15 Mar 2000 14:15:00 +0100

Dear RTP experts,

I'm prepared to be target of a massive flame attack, however I simply
cannot resist to post this:

I haven been asking myself the following (maybe naive) question for
some time: Why are SSRC IDs not reserved in a way that makes
sure that they are unique for a given session. 

IMHO the possibility of SSRC ID collisions contributes a lot to the 
complexity of a complete and correct RTP implementation. At least
for the RTP implementation I have done recently it would have been
a significant reduction of error prone code if the SSRC ID would
be constant and guaranteed to be unique. Essentially the whole 
problem dealt with in section 8 of the current draft would vanish. 
I do know that SSRC ID collisions are extremely rare. However, 
this makes it all the more likely that a given RTP implementation 
will not correctly handle a collision when it does occur. 

I am also aware that in order to reserve unique SSRC IDs, some 
centralized authority to distribute SSRC IDs (possibly
on a per session basis) is required. While in a multicast
centered environment this might seem odd (to put it mildly)
it does not seem to be really inappropriate. The network traffic
and processing for reserving SSRC IDs should be acceptable even
for large number of participants, since the required data is
really small (a couple of bytes, most likely the UDP/IP header would
account for more data than the content of the packet). In order 
to protect against the failure of a single server, the SSRC ID number 
space could be divided to be served by multiple (say a hundred?) servers. 

What am I missing? Something obvious?

I would appreciate any feedback ....

thanks for reading,

Martin
-- 
---------------------------------------------------------------------------
Martin Mauve                                         University of Mannheim
Praktische Informatik IV                            Phone: +49-621-181-2616
L 15,16                                             Fax  : +49-621-181-2601
68131 Mannheim                         [email-masked]
Germany
---------------------------------------------------------------------------